Bug 1312328 - New Package: openstack-ironic-staging-drivers
New Package: openstack-ironic-staging-drivers
Status: CLOSED CURRENTRELEASE
Product: RDO
Classification: Community
Component: Package Review (Show other bugs)
unspecified
Unspecified Unspecified
unspecified Severity unspecified
: ---
: trunk
Assigned To: Javier Peña
hguemar
: Reopened
Depends On:
Blocks: RDO-MITAKA/RDO-MITAKA-REVIEWS
  Show dependency treegraph
 
Reported: 2016-02-26 07:49 EST by Lucas Alvares Gomes
Modified: 2016-12-22 12:10 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-22 12:10:16 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jpena: rdo‑review+


Attachments (Terms of Use)

  None (edit)
Description Lucas Alvares Gomes 2016-02-26 07:49:23 EST
Description of problem:

Ironic decided that drivers living in tree will require a 3rd party CI for it. But, some developers/hobbyists have useful drivers in tree but no means to setup a CI for them, therefore many of these drivers (and new ones that never made it to the Ironic tree) are going to be moved into the ironic-staging-drivers project. Some drivers include but limited to: iBOOT, WOL, AMT and libvirt.

Drivers in the ironic-staging-drivers project will continue to be unittested against the Ironic code to ensure that all the driver's interfaces are not broken.


Additional info:

The official repository for the project is the https://github.com/openstack/ironic-staging-drivers
Comment 1 Dmitry Tantsur 2016-02-26 11:42:58 EST
packaging: https://github.com/dtantsur/ironic-staging-drivers-packaging/
Comment 3 Alan Pevec 2016-03-08 09:26:19 EST
Spec URL: https://raw.githubusercontent.com/umago/ironic-staging-drivers-packaging/master/openstack-ironic-staging-drivers.spec
SRPM URL: https://github.com/umago/ironic-staging-drivers-packaging/raw/master/openstack-ironic-staging-drivers-0.1.0-1.src.rpm
Description:
The Ironic Staging Drivers is used to hold out-of-tree Ironic drivers
which doesn't have means to provide a 3rd Party CI at this point in
time which is required by Ironic.
Comment 4 Chandan Kumar 2016-05-19 12:04:14 EDT
This bug is against a Version which has reached End of Life.
If it's still present in supported release (http://releases.openstack.org), please update Version and reopen.
Comment 5 Dmitry Tantsur 2016-05-19 12:06:46 EDT
Automation is good, but this is a package review, srsly :/
Comment 7 Chandan Kumar 2016-08-08 01:40:49 EDT
Hello Lucas,

Thanks for submitting it for package review.
Below is my comments:
[1.] Replace version and release to XXX

For RDO trunk, packaging has had Version: and Release: fields both set to XXX as dlrn takes both of these from the tags set on the git repositories. For <release>-rdo branches they must be manually set to the right version and release.

[2.] please use tarballs.openstack.org instead of pypi.python.org because the pypi url has changed.
Source0: http://tarballs.openstack.org/ironic-staging-drivers/ironic-staging-drivers-%{version}.tar.gz

[3.] BuildRequires and Requires are not synced with https://github.com/openstack/ironic-staging-drivers/blob/master/requirements.txt please sync it and if possible set the minimum versions of the packages.

[4.] %setup -q -n %{orig_name}-%{version} should be %setup -q -n %{orig_name}-%{version} -S git

[5.] This line rm -rf %{orig_name}.egg-info should be removed, Never try to delte egg files because it may contains some test fixtures.

[6.] Please create a test subpackage like %{name}-tests and add BuildRequires and Requires for the test subpackage from https://github.com/openstack/ironic-staging-drivers/blob/master/test-requirements.txt
For example on how to create a test subpackage: https://github.com/openstack-packages/openstack-example-spec/blob/master/openstack-example.spec#L50

[7.] tests can be runned in %check section using %{__python2} setup.py testr

[8.] Since the package contains docs, to build docs under %build section
# Build Documentation
sphinx-build doc/source html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}

and include generated 'html' folder under %doc html in %files directive of main package 

Rest looks ok to me.

Thanks,

Chandan Kumar
Comment 8 Lucas Alvares Gomes 2016-10-10 09:55:43 EDT
Thanks for the review Chandan and sorry for the delay to update this. Please find the comments below:

(In reply to Chandan Kumar from comment #7)
> Hello Lucas,
> 
> Thanks for submitting it for package review.
> Below is my comments:
> [1.] Replace version and release to XXX
> 
> For RDO trunk, packaging has had Version: and Release: fields both set to
> XXX as dlrn takes both of these from the tags set on the git repositories.
> For <release>-rdo branches they must be manually set to the right version
> and release.
> 

Sorry I don't get this. I'm looking at the RDO packaging guide for openstack [0] which just points me to the fedora guide and I don't see XXX rule. I've tried to add it and it failed to build the RPM. So I left it out.

Is there any better guide than [0] for newbies like me ? Cause honestly, [0] is a big turn off for people that just want to create a simple RPM.

[0] https://www.rdoproject.org/documentation/rdo-packaging-guidelines/

> [2.] please use tarballs.openstack.org instead of pypi.python.org because
> the pypi url has changed.
> Source0:
> http://tarballs.openstack.org/ironic-staging-drivers/ironic-staging-drivers-
> %{version}.tar.gz
> 

Done

> [3.] BuildRequires and Requires are not synced with
> https://github.com/openstack/ironic-staging-drivers/blob/master/requirements.
> txt please sync it and if possible set the minimum versions of the packages.
> 

Done

> [4.] %setup -q -n %{orig_name}-%{version} should be %setup -q -n
> %{orig_name}-%{version} -S git
> 

Done

> [5.] This line rm -rf %{orig_name}.egg-info should be removed, Never try to
> delte egg files because it may contains some test fixtures.
> 

Done

> [6.] Please create a test subpackage like %{name}-tests and add
> BuildRequires and Requires for the test subpackage from
> https://github.com/openstack/ironic-staging-drivers/blob/master/test-
> requirements.txt
> For example on how to create a test subpackage:
> https://github.com/openstack-packages/openstack-example-spec/blob/master/
> openstack-example.spec#L50
>  
> [7.] tests can be runned in %check section using %{__python2} setup.py testr
> 

For #6 and #7 I left it out, the example spec says that -tests package are for backward compat only and should be ignored for new packages [1]

[1] https://github.com/openstack-packages/openstack-example-spec/blob/84350ecdde484f24b11d3fbf964252300eea3afa/openstack-example.spec#L59-L60

> [8.] Since the package contains docs, to build docs under %build section
> # Build Documentation
> sphinx-build doc/source html
> # remove the sphinx-build leftovers
> rm -rf html/.{doctrees,buildinfo}
> 
> and include generated 'html' folder under %doc html in %files directive of
> main package 
> 

Done

Here's the new .spec and SRPM:

spec: https://raw.githubusercontent.com/umago/ironic-staging-drivers-packaging/master/openstack-ironic-staging-drivers.spec

SRPM: https://raw.githubusercontent.com/umago/ironic-staging-drivers-packaging/master/openstack-ironic-staging-drivers-0.3.0-1.src.rpm
Comment 10 Javier Peña 2016-12-14 12:04:28 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated", "*No copyright* Apache
     (v2.0)". 18 files have unknown license. Detailed output of
     licensecheck in /tmp/review-openstack-ironic-staging-
     drivers/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python2.7/site-
     packages/ironic_staging_drivers
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0: http://tarballs.openstack.org
     /ironic-staging-drivers/ironic-staging-drivers-0.4.1.tar.gz
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     openstack-ironic-staging-drivers-doc , openstack-ironic-staging-
     drivers-tests
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[-]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: openstack-ironic-staging-drivers-0.4.1-0.20161208141827.fd7a07f.el7.centos.noarch.rpm
          openstack-ironic-staging-drivers-doc-0.4.1-0.20161208141827.fd7a07f.el7.centos.noarch.rpm
          openstack-ironic-staging-drivers-tests-0.4.1-0.20161208141827.fd7a07f.el7.centos.noarch.rpm
          openstack-ironic-staging-drivers-0.4.1-0.20161208141827.fd7a07f.el7.centos.src.rpm
openstack-ironic-staging-drivers.noarch: E: no-changelogname-tag
openstack-ironic-staging-drivers.noarch: W: invalid-url URL: http://launchpad.net/ironic-staging-drivers/ The read operation timed out
openstack-ironic-staging-drivers.noarch: W: no-documentation
openstack-ironic-staging-drivers.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironic_staging_drivers/ansible/playbooks/library/stream_url.py 644 /usr/bin/python 
openstack-ironic-staging-drivers.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironic_staging_drivers/ansible/playbooks/library/parted.py 644 /usr/bin/python 
openstack-ironic-staging-drivers-doc.noarch: E: no-changelogname-tag
openstack-ironic-staging-drivers-doc.noarch: W: file-not-utf8 /usr/share/doc/openstack-ironic-staging-drivers-doc-0.4.1/html/objects.inv
openstack-ironic-staging-drivers-doc.noarch: W: hidden-file-or-dir /usr/share/doc/openstack-ironic-staging-drivers-doc-0.4.1/html/.buildinfo
openstack-ironic-staging-drivers-tests.noarch: E: no-changelogname-tag
openstack-ironic-staging-drivers-tests.noarch: W: no-documentation
openstack-ironic-staging-drivers-tests.noarch: E: zero-length /usr/lib/python2.7/site-packages/ironic_staging_drivers/tests/unit/utils.py
openstack-ironic-staging-drivers.src: E: no-changelogname-tag
openstack-ironic-staging-drivers.src: W: invalid-url Source0: ironic-staging-drivers-0.4.1.dev1-0.20161208141827.fd7a07f.tar.gz
4 packages and 0 specfiles checked; 7 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
openstack-ironic-staging-drivers-tests.noarch: E: no-changelogname-tag
openstack-ironic-staging-drivers-tests.noarch: W: no-documentation
openstack-ironic-staging-drivers-tests.noarch: E: zero-length /usr/lib/python2.7/site-packages/ironic_staging_drivers/tests/unit/utils.py
openstack-ironic-staging-drivers-doc.noarch: E: no-changelogname-tag
openstack-ironic-staging-drivers-doc.noarch: W: hidden-file-or-dir /usr/share/doc/openstack-ironic-staging-drivers-doc-0.4.1/html/.buildinfo
openstack-ironic-staging-drivers.noarch: E: explicit-lib-dependency python-ironic-lib
openstack-ironic-staging-drivers.noarch: E: no-changelogname-tag
openstack-ironic-staging-drivers.noarch: W: no-documentation
openstack-ironic-staging-drivers.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironic_staging_drivers/ansible/playbooks/library/stream_url.py 0644L /usr/bin/python
openstack-ironic-staging-drivers.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironic_staging_drivers/ansible/playbooks/library/parted.py 0644L /usr/bin/python
3 packages and 0 specfiles checked; 7 errors, 3 warnings.



Diff spec file in url and in SRPM
---------------------------------
--- /tmp/openstack-ironic-staging-drivers.spec	2016-12-14 17:54:14.304792252 +0100
+++ /tmp/review-openstack-ironic-staging-drivers/srpm-unpacked/openstack-ironic-staging-drivers.spec	2016-12-08 15:18:27.000000000 +0100
@@ -1,2 +1,4 @@
+%global dlrn 1
+%define upstream_version 0.4.1.dev1
 %{!?upstream_version: %global upstream_version %{version}%{?milestone}}
 
@@ -6,10 +8,10 @@
 Name: openstack-%{sname}
 Version: 0.4.1
-Release: 0.20161208141827.fd7a07f
+Release: 0.20161208141827.fd7a07f%{?dist}
 Summary: Staging drivers for OpenStack Ironic
 License: ASL 2.0
 URL: http://launchpad.net/%{sname}/
 
-Source0: http://tarballs.openstack.org/%{sname}/%{sname}-%{upstream_version}.tar.gz
+Source0: ironic-staging-drivers-0.4.1.dev1-0.20161208141827.fd7a07f.tar.gz
 
 BuildArch: noarch
@@ -86,4 +88,2 @@
 
 %changelog
-* Tue Dec 06 2016 Lucas Alvares Gomes <lucasagomes@gmail.com> 0.4.0-1
-– Initial Packaging


Requires
--------
openstack-ironic-staging-drivers-tests (rpmlib, GLIBC filtered):
    python(abi)
    python-mock
    python-os-testr
    python-oslotest
    python-testresources

openstack-ironic-staging-drivers-doc (rpmlib, GLIBC filtered):

openstack-ironic-staging-drivers (rpmlib, GLIBC filtered):
    /bin/sh
    python(abi)
    python-ironic-lib
    python-jsonschema
    python-oslo-concurrency
    python-oslo-config
    python-oslo-i18n
    python-oslo-log
    python-oslo-service
    python-oslo-utils
    python-six



Provides
--------
openstack-ironic-staging-drivers-tests:
    openstack-ironic-staging-drivers-tests

openstack-ironic-staging-drivers-doc:
    openstack-ironic-staging-drivers-doc

openstack-ironic-staging-drivers:
    openstack-ironic-staging-drivers



Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -n openstack-ironic-staging-drivers -m dlrn
Buildroot used: dlrn-centos7-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

The warnings related to differences between the spec in file and srpm, and being unable to download the source are expected, because the srpm was generated by DLRN.

The package is APPROVED, please proceed with step 2 from https://www.rdoproject.org/documentation/rdo-packaging/#how-to-add-a-new-package-to-rdo-trunk
Comment 11 Javier Peña 2016-12-22 12:10:16 EST
The package is now available from the RDO Trunk repo: https://trunk.rdoproject.org/centos7/current/

Note You need to log in before you can comment on or make changes to this bug.